diff --git a/gcc/testsuite/c-c++-common/goacc/loop-shape.c b/gcc/testsuite/c-c++-common/goacc/loop-shape.c
index 9708f7bf5eb3..b3199b4044d0 100644
--- a/gcc/testsuite/c-c++-common/goacc/loop-shape.c
+++ b/gcc/testsuite/c-c++-common/goacc/loop-shape.c
@@ -1,7 +1,7 @@
 /* Exercise *_parser_oacc_shape_clause by checking various combinations
    of gang, worker and vector clause arguments.  */
 
-/* { dg-compile } */
+/* { dg-do compile } */
 
 int main ()
 {
diff --git a/gcc/testsuite/g++.dg/pr83979.C b/gcc/testsuite/g++.dg/pr83979.C
index a39b1ea6ab9b..0ef754d1e48d 100644
--- a/gcc/testsuite/g++.dg/pr83979.C
+++ b/gcc/testsuite/g++.dg/pr83979.C
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 int
 foo (char* p)
diff --git a/gcc/testsuite/g++.target/aarch64/sve/acle/general-c++/attributes_2.C b/gcc/testsuite/g++.target/aarch64/sve/acle/general-c++/attributes_2.C
index b55be02ecca2..c8f1ad403e67 100644
--- a/gcc/testsuite/g++.target/aarch64/sve/acle/general-c++/attributes_2.C
+++ b/gcc/testsuite/g++.target/aarch64/sve/acle/general-c++/attributes_2.C
@@ -1,4 +1,4 @@
-// { dg-compile }
+// { dg-do compile }
 // { dg-additional-options "-msve-vector-bits=512" }
 
 #include <arm_sve.h>
diff --git a/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-7.c b/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-7.c
index 29954aabfdb4..eca4e9080926 100644
--- a/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-7.c
+++ b/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-7.c
@@ -1,6 +1,6 @@
 /* PR tree-optimization/77671 - missing -Wformat-overflow warning
    on sprintf overflow with "%s"
-   { dg-compile }
+   { dg-do compile }
    { dg-options "-O2 -Wformat -Wno-format-zero-length -fdump-tree-optimized" } */
 
 void sink (char*);
diff --git a/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-8.c b/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-8.c
index 2d38d12bcc22..da1088c5fffd 100644
--- a/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-8.c
+++ b/gcc/testsuite/gcc.dg/tree-ssa/builtin-sprintf-8.c
@@ -5,7 +5,7 @@
    be transformed into calls to other functions (such as memcpy)
    are preserved.
 
-   { dg-compile }
+   { dg-do compile }
    { dg-options "-O2 -Wformat -Wno-format-truncation -Wno-format-zero-length -fdump-tree-optimized" } */
 
 void sink (char*, ...);
diff --git a/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-char.c b/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-char.c
index 85841fd7036c..58211207186c 100644
--- a/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-char.c
+++ b/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-char.c
@@ -1,5 +1,5 @@
 /* Test __atomic routines for existence on 2 byte values with each valid memory model.  */
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-Wno-address-of-packed-member" } */
 /* { dg-add-options riscv_zabha } */
 /* { dg-remove-options riscv_ztso } */
diff --git a/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-short.c b/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-short.c
index edc0a2c8f8e3..c846ca48d728 100644
--- a/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-short.c
+++ b/gcc/testsuite/gcc.target/riscv/amo/zabha-rvwmo-all-amo-ops-short.c
@@ -1,5 +1,5 @@
 /* Test __atomic routines for existence on 2 byte values with each valid memory model.  */
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-Wno-address-of-packed-member" } */
 /* { dg-add-options riscv_zabha } */
 /* { dg-remove-options riscv_ztso } */
diff --git a/gcc/testsuite/gcc.target/s390/20181024-1.c b/gcc/testsuite/gcc.target/s390/20181024-1.c
index 830ab5b927ce..66415ce9ce29 100644
--- a/gcc/testsuite/gcc.target/s390/20181024-1.c
+++ b/gcc/testsuite/gcc.target/s390/20181024-1.c
@@ -1,5 +1,5 @@
 /* Make sure s390_check_qrst_address () correctly handles UNSPEC rtxs.  */
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-march=z196 -O2 -fPIC" } */
 
 int a, b, g, h;
diff --git a/gcc/testsuite/gcc.target/s390/addr-constraints-1.c b/gcc/testsuite/gcc.target/s390/addr-constraints-1.c
index fbb48f282b3b..165a0828cc43 100644
--- a/gcc/testsuite/gcc.target/s390/addr-constraints-1.c
+++ b/gcc/testsuite/gcc.target/s390/addr-constraints-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O2" } */
 
 static inline unsigned long
diff --git a/gcc/testsuite/gcc.target/s390/arch12/aghsghmgh-1.c b/gcc/testsuite/gcc.target/s390/arch12/aghsghmgh-1.c
index fc844c3e4042..29cbecb691c2 100644
--- a/gcc/testsuite/gcc.target/s390/arch12/aghsghmgh-1.c
+++ b/gcc/testsuite/gcc.target/s390/arch12/aghsghmgh-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 long long
 agh (long long a, short int *p)
diff --git a/gcc/testsuite/gcc.target/s390/arch12/mul-1.c b/gcc/testsuite/gcc.target/s390/arch12/mul-1.c
index ef395356b72a..da0421b8385d 100644
--- a/gcc/testsuite/gcc.target/s390/arch12/mul-1.c
+++ b/gcc/testsuite/gcc.target/s390/arch12/mul-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 int
 msrkc (int unused, int a, int b)
diff --git a/gcc/testsuite/gcc.target/s390/arch13/bitops-1.c b/gcc/testsuite/gcc.target/s390/arch13/bitops-1.c
index fd49fb97630d..8d84655f71cc 100644
--- a/gcc/testsuite/gcc.target/s390/arch13/bitops-1.c
+++ b/gcc/testsuite/gcc.target/s390/arch13/bitops-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 /* and with complement */
 
diff --git a/gcc/testsuite/gcc.target/s390/arch13/bitops-2.c b/gcc/testsuite/gcc.target/s390/arch13/bitops-2.c
index fde96034c55a..1bfada3b05ab 100644
--- a/gcc/testsuite/gcc.target/s390/arch13/bitops-2.c
+++ b/gcc/testsuite/gcc.target/s390/arch13/bitops-2.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 /* Check if the instruction are being used also for compares.  */
 
diff --git a/gcc/testsuite/gcc.target/s390/arch13/fp-signedint-convert-1.c b/gcc/testsuite/gcc.target/s390/arch13/fp-signedint-convert-1.c
index 9801da86cf36..9c9ea2a55044 100644
--- a/gcc/testsuite/gcc.target/s390/arch13/fp-signedint-convert-1.c
+++ b/gcc/testsuite/gcc.target/s390/arch13/fp-signedint-convert-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 typedef int __attribute__((vector_size(16))) v4si;
 typedef float __attribute__((vector_size(16))) v4sf;
diff --git a/gcc/testsuite/gcc.target/s390/arch13/fp-unsignedint-convert-1.c b/gcc/testsuite/gcc.target/s390/arch13/fp-unsignedint-convert-1.c
index b93b95daf252..1369ad6ff465 100644
--- a/gcc/testsuite/gcc.target/s390/arch13/fp-unsignedint-convert-1.c
+++ b/gcc/testsuite/gcc.target/s390/arch13/fp-unsignedint-convert-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 typedef unsigned int __attribute__((vector_size(16))) v4si;
 typedef float __attribute__((vector_size(16))) v4sf;
diff --git a/gcc/testsuite/gcc.target/s390/arch13/popcount-1.c b/gcc/testsuite/gcc.target/s390/arch13/popcount-1.c
index c98a3272a028..92d5acb93dc7 100644
--- a/gcc/testsuite/gcc.target/s390/arch13/popcount-1.c
+++ b/gcc/testsuite/gcc.target/s390/arch13/popcount-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 
 unsigned int ui;
 unsigned long ul;
diff --git a/gcc/testsuite/gcc.target/s390/pr68015.c b/gcc/testsuite/gcc.target/s390/pr68015.c
index b0d1f35ad1a8..47adc63d7f73 100644
--- a/gcc/testsuite/gcc.target/s390/pr68015.c
+++ b/gcc/testsuite/gcc.target/s390/pr68015.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O2 -march=z196" } */
 
 extern long useme (long, ...);
diff --git a/gcc/testsuite/gcc.target/s390/vector/fp-signedint-convert-1.c b/gcc/testsuite/gcc.target/s390/vector/fp-signedint-convert-1.c
index 536817aa5af7..69dddf222678 100644
--- a/gcc/testsuite/gcc.target/s390/vector/fp-signedint-convert-1.c
+++ b/gcc/testsuite/gcc.target/s390/vector/fp-signedint-convert-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -march=z13 -mzarch" } */
 
 typedef long long __attribute__((vector_size(16))) v2di;
diff --git a/gcc/testsuite/gcc.target/s390/vector/fp-unsignedint-convert-1.c b/gcc/testsuite/gcc.target/s390/vector/fp-unsignedint-convert-1.c
index 61409bcfc73a..578e72f5682d 100644
--- a/gcc/testsuite/gcc.target/s390/vector/fp-unsignedint-convert-1.c
+++ b/gcc/testsuite/gcc.target/s390/vector/fp-unsignedint-convert-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -march=z13 -mzarch" } */
 
 typedef unsigned long long __attribute__((vector_size(16))) v2di;
diff --git a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-1.c b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-1.c
index 4a2541b7ae6f..39e4a9b3e28b 100644
--- a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-1.c
+++ b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-1.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -march=z13" } */
 /* { dg-require-effective-target s390_vx } */
 /* { dg-final { scan-assembler-times {\tvpdi\t} 4 } } */
diff --git a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-2.c b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-2.c
index ec0d1da7d571..25597042ee89 100644
--- a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-2.c
+++ b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-2.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -march=z14" } */
 /* { dg-require-effective-target s390_vxe } */
 /* { dg-final { scan-assembler-times {\tvpdi\t} 1 } } */
diff --git a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-3.c b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-3.c
index 3f69db8831cf..ad0b8e6e604b 100644
--- a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-3.c
+++ b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-3.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -march=z14" } */
 /* { dg-require-effective-target s390_vxe } */
 /* { dg-final { scan-assembler-times {\tvpdi\t} 5 } } */
diff --git a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-4.c b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-4.c
index 5027ed55f500..f386d559174f 100644
--- a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-4.c
+++ b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-4.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -march=z15" } */
 /* { dg-require-effective-target s390_vxe2 } */
 /* { dg-final { scan-assembler-times {\tvlbrq\t} 1 } } */
diff --git a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-5.c b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-5.c
index 8c250aa681b9..f7403784bfeb 100644
--- a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-5.c
+++ b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-5.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -march=z14" } */
 /* { dg-require-effective-target s390_vxe } */
 /* { dg-final { scan-assembler-times {\tvpdi\t} 5 } } */
diff --git a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-6.c b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-6.c
index 7e2b23567880..a73109170d43 100644
--- a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-6.c
+++ b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-6.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -march=z15" } */
 /* { dg-require-effective-target s390_vxe2 } */
 /* { dg-final { scan-assembler-times {\tvstbrq\t} 1 } } */
diff --git a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-7.c b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-7.c
index 046fcc0790a6..453b870a5a51 100644
--- a/gcc/testsuite/gcc.target/s390/vector/reverse-elements-7.c
+++ b/gcc/testsuite/gcc.target/s390/vector/reverse-elements-7.c
@@ -1,4 +1,4 @@
-/* { dg-compile } */
+/* { dg-do compile } */
 /* { dg-options "-O3 -mzarch -march=z15" } */
 /* { dg-require-effective-target s390_vxe2 } */
 /* { dg-final { scan-assembler-times {\tvstbrq\t} 1 } } */
diff --git a/gcc/testsuite/gnat.dg/alignment15.adb b/gcc/testsuite/gnat.dg/alignment15.adb
index e58243d29084..72d3746dff8c 100644
--- a/gcc/testsuite/gnat.dg/alignment15.adb
+++ b/gcc/testsuite/gnat.dg/alignment15.adb
@@ -1,4 +1,4 @@
---  { dg-compile }
+--  { dg-do compile }
 
 procedure Alignment15 is
    type T0 is record
diff --git a/gcc/testsuite/gnat.dg/debug4.adb b/gcc/testsuite/gnat.dg/debug4.adb
index 1ec37c2aa3b0..1543cdca81c6 100644
--- a/gcc/testsuite/gnat.dg/debug4.adb
+++ b/gcc/testsuite/gnat.dg/debug4.adb
@@ -1,4 +1,4 @@
--- { dg-compile }
+-- { dg-do compile }
 -- { dg-options "-g" }
 
 with Debug4_Pkg;
diff --git a/gcc/testsuite/gnat.dg/inline21.adb b/gcc/testsuite/gnat.dg/inline21.adb
index 5df569158eb3..5cdd3626898e 100644
--- a/gcc/testsuite/gnat.dg/inline21.adb
+++ b/gcc/testsuite/gnat.dg/inline21.adb
@@ -1,4 +1,4 @@
---  { dg-compile }
+--  { dg-do compile }
 --  { dg-options "-O -gnatn" }
 
 with Inline21_Q;
diff --git a/gcc/testsuite/gnat.dg/inline22.adb b/gcc/testsuite/gnat.dg/inline22.adb
index 5812c2f04dfd..00f94c8789bb 100644
--- a/gcc/testsuite/gnat.dg/inline22.adb
+++ b/gcc/testsuite/gnat.dg/inline22.adb
@@ -1,4 +1,4 @@
--- { dg-compile }
+-- { dg-do compile }
 
 procedure Inline22 (L, U : Integer) is
 
diff --git a/gcc/testsuite/gnat.dg/opt37.adb b/gcc/testsuite/gnat.dg/opt37.adb
index 0e3ee53a1589..52585af77f09 100644
--- a/gcc/testsuite/gnat.dg/opt37.adb
+++ b/gcc/testsuite/gnat.dg/opt37.adb
@@ -1,4 +1,4 @@
--- { dg-compile }
+-- { dg-do compile }
 -- { dg-options "-O2 -gnato -fdump-tree-optimized" }
 
 package body Opt37 is
diff --git a/gcc/testsuite/gnat.dg/warn13.adb b/gcc/testsuite/gnat.dg/warn13.adb
index 2a9c4e392ccf..6fcd11a0c940 100644
--- a/gcc/testsuite/gnat.dg/warn13.adb
+++ b/gcc/testsuite/gnat.dg/warn13.adb
@@ -1,4 +1,4 @@
--- { dg-compile }
+-- { dg-do compile }
 
 procedure Warn13 is
 